
-- ͻ
--        D E S I G N   E N G I N E R I N G              DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         Package   Keys.ads                                         
--                                                                    
--         Author :  Leonid Dulman     1994-1996                      
--                                                                    
--          Values as returned from getkey() and getxkey()            
--                                                                    
-- ͼ

package Keys is
pragma preelaborate(Keys);

 K_Control_A            :constant integer:=16#001#;
 K_Control_B            :constant integer:=16#002#;
 K_Control_C            :constant integer:=16#003#;
 K_Control_D            :constant integer:=16#004#;
 K_Control_E            :constant integer:=16#005#;
 K_Control_F            :constant integer:=16#006#;
 K_Control_G            :constant integer:=16#007#;
 K_BackSpace            :constant integer:=16#008#;
 K_Control_H            :constant integer:=16#008#;
 K_Tab                  :constant integer:=16#009#;
 K_Control_I            :constant integer:=16#009#;
 K_LineFeed             :constant integer:=16#00a#;
 K_Control_J            :constant integer:=16#00a#;
 K_Control_K            :constant integer:=16#00b#;
 K_Control_L            :constant integer:=16#00c#;
 K_Return               :constant integer:=16#00d#;
 K_Control_M            :constant integer:=16#00d#;
 K_Control_N            :constant integer:=16#00e#;
 K_Control_O            :constant integer:=16#00f#;
 K_Control_P            :constant integer:=16#010#;
 K_Control_Q            :constant integer:=16#011#;
 K_Control_R            :constant integer:=16#012#;
 K_Control_S            :constant integer:=16#013#;
 K_Control_T            :constant integer:=16#014#;
 K_Control_U            :constant integer:=16#015#;
 K_Control_V            :constant integer:=16#016#;
 K_Control_W            :constant integer:=16#017#;
 K_Control_X            :constant integer:=16#018#;
 K_Control_Y            :constant integer:=16#019#;
 K_Control_Z            :constant integer:=16#01a#;
 K_Control_LBracket     :constant integer:=16#01a#;
 K_Escape               :constant integer:=16#01b#;
 K_Control_BackSlash    :constant integer:=16#01c#;
 K_Control_RBracket     :constant integer:=16#01d#;
 K_Control_Caret        :constant integer:=16#01e#;
 K_Control_Underscore   :constant integer:=16#01f#;
 K_Space                :constant integer:=16#020#;
 K_ExclamationPoint     :constant integer:=16#021#;
 K_DoubleQuote          :constant integer:=16#022#;
 K_Hash                 :constant integer:=16#023#;
 K_Dollar               :constant integer:=16#024#;
 K_Percent              :constant integer:=16#025#;
 K_Ampersand            :constant integer:=16#026#;
 K_Quote                :constant integer:=16#027#;
 K_LParen               :constant integer:=16#028#;
 K_RParen               :constant integer:=16#029#;
 K_Star                 :constant integer:=16#02a#;
 K_Plus                 :constant integer:=16#02b#;
 K_Comma                :constant integer:=16#02c#;
 K_Dash                 :constant integer:=16#02d#;
 K_Period               :constant integer:=16#02e#;
 K_Slash                :constant integer:=16#02f#;
 K_Colon                :constant integer:=16#03a#;
 K_SemiColon            :constant integer:=16#03b#;
 K_LAngle               :constant integer:=16#03c#;
 K_Equals               :constant integer:=16#03d#;
 K_RAngle               :constant integer:=16#03e#;
 K_QuestionMark         :constant integer:=16#03f#;
 K_At                   :constant integer:=16#040#;
 K_LBracket             :constant integer:=16#05b#;
 K_BackSlash            :constant integer:=16#05c#;
 K_RBracket             :constant integer:=16#05d#;
 K_Caret                :constant integer:=16#05e#;
 K_UnderScore           :constant integer:=16#05f#;
 K_BackQuote            :constant integer:=16#060#;
 K_LBrace               :constant integer:=16#07b#;
 K_Pipe                 :constant integer:=16#07c#;
 K_RBrace               :constant integer:=16#07d#;
 K_Tilde                :constant integer:=16#07e#;
 K_Control_Backspace    :constant integer:=16#07f#;

 K_Alt_Escape           :constant integer:=16#101#;
 K_Control_At           :constant integer:=16#103#;
 K_Alt_Backspace        :constant integer:=16#10e#;
 K_BackTab              :constant integer:=16#10f#;
 K_Alt_Q                :constant integer:=16#110#;
 K_Alt_W                :constant integer:=16#111#;
 K_Alt_E                :constant integer:=16#112#;
 K_Alt_R                :constant integer:=16#113#;
 K_Alt_T                :constant integer:=16#114#;
 K_Alt_Y                :constant integer:=16#115#;
 K_Alt_U                :constant integer:=16#116#;
 K_Alt_I                :constant integer:=16#117#;
 K_Alt_O                :constant integer:=16#118#;
 K_Alt_P                :constant integer:=16#119#;
 K_Alt_LBracket         :constant integer:=16#11a#;
 K_Alt_RBracket         :constant integer:=16#11b#;
 K_Alt_Return           :constant integer:=16#11c#;
 K_Alt_A                :constant integer:=16#11e#;
 K_Alt_S                :constant integer:=16#11f#;
 K_Alt_D                :constant integer:=16#120#;
 K_Alt_F                :constant integer:=16#121#;
 K_Alt_G                :constant integer:=16#122#;
 K_Alt_H                :constant integer:=16#123#;
 K_Alt_J                :constant integer:=16#124#;
 K_Alt_K                :constant integer:=16#125#;
 K_Alt_L                :constant integer:=16#126#;
 K_Alt_Semicolon        :constant integer:=16#127#;
 K_Alt_Quote            :constant integer:=16#128#;
 K_Alt_Backquote        :constant integer:=16#129#;
 K_Alt_Backslash        :constant integer:=16#12b#;
 K_Alt_Z                :constant integer:=16#12c#;
 K_Alt_X                :constant integer:=16#12d#;
 K_Alt_C                :constant integer:=16#12e#;
 K_Alt_V                :constant integer:=16#12f#;
 K_Alt_B                :constant integer:=16#130#;
 K_Alt_N                :constant integer:=16#131#;
 K_Alt_M                :constant integer:=16#132#;
 K_Alt_Comma            :constant integer:=16#133#;
 K_Alt_Period           :constant integer:=16#134#;
 K_Alt_Slash            :constant integer:=16#135#;
 K_Alt_KPStar           :constant integer:=16#137#;
 K_F1                   :constant integer:=16#13b#;
 K_F2                   :constant integer:=16#13c#;
 K_F3                   :constant integer:=16#13d#;
 K_F4                   :constant integer:=16#13e#;
 K_F5                   :constant integer:=16#13f#;
 K_F6                   :constant integer:=16#140#;
 K_F7                   :constant integer:=16#141#;
 K_F8                   :constant integer:=16#142#;
 K_F9                   :constant integer:=16#143#;
 K_F10                  :constant integer:=16#144#;
 K_Home                 :constant integer:=16#147#;
 K_Up                   :constant integer:=16#148#;
 K_PageUp               :constant integer:=16#149#;
 K_Alt_KPMinus          :constant integer:=16#14a#;
 K_Left                 :constant integer:=16#14b#;
 K_Center               :constant integer:=16#14c#;
 K_Right                :constant integer:=16#14d#;
 K_Alt_KPPlus           :constant integer:=16#14e#;
 K_End                  :constant integer:=16#14f#;
 K_Down                 :constant integer:=16#150#;
 K_PageDown             :constant integer:=16#151#;
 K_Insert               :constant integer:=16#152#;
 K_Delete               :constant integer:=16#153#;
 K_Shift_F1             :constant integer:=16#154#;
 K_Shift_F2             :constant integer:=16#155#;
 K_Shift_F3             :constant integer:=16#156#;
 K_Shift_F4             :constant integer:=16#157#;
 K_Shift_F5             :constant integer:=16#158#;
 K_Shift_F6             :constant integer:=16#159#;
 K_Shift_F7             :constant integer:=16#15a#;
 K_Shift_F8             :constant integer:=16#15b#;
 K_Shift_F9             :constant integer:=16#15c#;
 K_Shift_F10            :constant integer:=16#15d#;
 K_Control_F1           :constant integer:=16#15e#;
 K_Control_F2           :constant integer:=16#15f#;
 K_Control_F3           :constant integer:=16#160#;
 K_Control_F4           :constant integer:=16#161#;
 K_Control_F5           :constant integer:=16#162#;
 K_Control_F6           :constant integer:=16#163#;
 K_Control_F7           :constant integer:=16#164#;
 K_Control_F8           :constant integer:=16#165#;
 K_Control_F9           :constant integer:=16#166#;
 K_Control_F10          :constant integer:=16#167#;
 K_Alt_F1               :constant integer:=16#168#;
 K_Alt_F2               :constant integer:=16#169#;
 K_Alt_F3               :constant integer:=16#16a#;
 K_Alt_F4               :constant integer:=16#16b#;
 K_Alt_F5               :constant integer:=16#16c#;
 K_Alt_F6               :constant integer:=16#16d#;
 K_Alt_F7               :constant integer:=16#16e#;
 K_Alt_F8               :constant integer:=16#16f#;
 K_Alt_F9               :constant integer:=16#170#;
 K_Alt_F10              :constant integer:=16#171#;
 K_Control_Left         :constant integer:=16#173#;
 K_Control_Right        :constant integer:=16#174#;
 K_Control_End          :constant integer:=16#175#;
 K_Control_PageDown     :constant integer:=16#176#;
 K_Control_Home         :constant integer:=16#177#;
 K_Alt_1                :constant integer:=16#178#;
 K_Alt_2                :constant integer:=16#179#;
 K_Alt_3                :constant integer:=16#17a#;
 K_Alt_4                :constant integer:=16#17b#;
 K_Alt_5                :constant integer:=16#17c#;
 K_Alt_6                :constant integer:=16#17d#;
 K_Alt_7                :constant integer:=16#17e#;
 K_Alt_8                :constant integer:=16#17f#;
 K_Alt_9                :constant integer:=16#180#;
 K_Alt_0                :constant integer:=16#181#;
 K_Alt_Dash             :constant integer:=16#182#;
 K_Alt_Equals           :constant integer:=16#183#;
 K_Control_PageUp       :constant integer:=16#184#;
 K_F11                  :constant integer:=16#185#;
 K_F12                  :constant integer:=16#186#;
 K_Shift_F11            :constant integer:=16#187#;
 K_Shift_F12            :constant integer:=16#188#;
 K_Control_F11          :constant integer:=16#189#;
 K_Control_F12          :constant integer:=16#18a#;
 K_Alt_F11              :constant integer:=16#18b#;
 K_Alt_F12              :constant integer:=16#18c#;
 K_Control_Up           :constant integer:=16#18d#;
 K_Control_KPDash       :constant integer:=16#18e#;
 K_Control_Center       :constant integer:=16#18f#;
 K_Control_KPPlus       :constant integer:=16#190#;
 K_Control_Down         :constant integer:=16#191#;
 K_Control_Insert       :constant integer:=16#192#;
 K_Control_Delete       :constant integer:=16#193#;
 K_Control_KPSlash      :constant integer:=16#195#;
 K_Control_KPStar       :constant integer:=16#196#;
 K_Alt_EHome            :constant integer:=16#197#;
 K_Alt_EUp              :constant integer:=16#198#;
 K_Alt_EPageUp          :constant integer:=16#199#;
 K_Alt_ELeft            :constant integer:=16#19b#;
 K_Alt_ERight           :constant integer:=16#19d#;
 K_Alt_EEnd             :constant integer:=16#19f#;
 K_Alt_EDown            :constant integer:=16#1a0#;
 K_Alt_EPageDown        :constant integer:=16#1a1#;
 K_Alt_EInsert          :constant integer:=16#1a2#;
 K_Alt_EDelete          :constant integer:=16#1a3#;
 K_Alt_KPSlash          :constant integer:=16#1a4#;
 K_Alt_Tab              :constant integer:=16#1a5#;
 K_Alt_Enter            :constant integer:=16#1a6#;

 K_EHome                :constant integer:=16#247#;
 K_EUp                  :constant integer:=16#248#;
 K_EPageUp              :constant integer:=16#249#;
 K_ELeft                :constant integer:=16#24b#;
 K_ERight               :constant integer:=16#24d#;
 K_EEnd                 :constant integer:=16#24f#;
 K_EDown                :constant integer:=16#250#;
 K_EPageDown            :constant integer:=16#251#;
 K_EInsert              :constant integer:=16#252#;
 K_EDelete              :constant integer:=16#253#;
 K_Control_ELeft        :constant integer:=16#273#;
 K_Control_ERight       :constant integer:=16#274#;
 K_Control_EEnd         :constant integer:=16#275#;
 K_Control_EPageDown    :constant integer:=16#276#;
 K_Control_EHome        :constant integer:=16#277#;
 K_Control_EPageUp      :constant integer:=16#284#;
 K_Control_EUp          :constant integer:=16#28d#;
 K_Control_EDown        :constant integer:=16#291#;
 K_Control_EInsert      :constant integer:=16#292#;
 K_Control_EDelete      :constant integer:=16#293#;
end Keys ;
